/*
 * 16F88_Ref3_ADC
 * ADRo[^̓mFpvO@ADRo[^̒lVAj^ɕ\
 * 
 * File:   main.c
 * Author: Taichi
 *
 * Created on 2017/02/22, 11:14
 */

// CONFIG1
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off)
#pragma config CCPMX = RB3      // CCP1 Pin Selection bit (CCP1 function on RB3)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

// CONFIG2
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)

#define _XTAL_FREQ 8000000      // 8MHz

#define LED1 RA0 // True ON LED
#define LED2 RA6 // False ON LED
#define SWITCH1 RA1 // Pull Down Switch
#define SWITCH2 RA7 // Pull Up Switch
#define VOLUME RA4 // VR1
#define SENSOR RB4 // Photo Sensor
#define M_IN1 RA2 // H-bridge IN1
#define M_IN2 RA3 // H-bridge IN2
#define TR RB3 // Transistor

#include <xc.h>
#include <stdio.h>
#include "uart.h"

// vg^Cv錾
void setADCChannel(unsigned char channel);
unsigned int readADCValue(void);

void main(void) {
    int ans;
    
    OSCCON = 0b01110000;    // NbN̎g8MHzɐݒ
 
    PORTA = 0x00;           // PORTA
    PORTB = 0x00;           // PORTB
    TRISA = 0b10010010;     // PORTA̓o͐ݒ RA1,7SWITCH, RA4VOLUME
    TRISB = 0b00010100;     // PORTB̓o͐ݒ RB2RX, RB4SENSOR

    ANSEL = 0b00010000;     // AN4L
    ADCON0 = 0b10000001;    // 110:Fosc/64(擪1ADCON1bit6, 1:ADON
    ADCON1 = 0b11000000;    // El, AVdd, AVss(ddƂ)   
    
    initUART();             // VAʐMݒ
    __delay_ms(100);
      
    while(1){
        setADCChannel(4);        // A/DϊΏۃ`lݒ
        __delay_us(50);                     // ANBWVԁi50}CNbj
        ans = readADCValue();            // A/Dϊl擾
        printf("ADC: %d\n", ans);      // A/Dϊl𑗐M
 
        __delay_ms(250);                    // 250~b̑҂
    }
}


// A/DϊΏۃ`lݒ֐
void setADCChannel(unsigned char channel)
{
    ADCON0 &= 0b11000111;               // CHS<2:0> bit3,4,5
    ADCON0 |= (channel << 3);
}
 

 // A/Dϊl擾֐ A/Dϊli10bit, 0-1023jԂ
unsigned int readADCValue(void)
{
    GO_nDONE = 0b1; // ADϊJn
    while(GO_nDONE); // ADϊAGO_nDONE1
    return ((ADRESH << 8) + ADRESL);
}